/* Widget functions recommended by Apple Developer Connection */


// Flip to back
function showBack(){
	var front=document.getElementById("front");
	var back=document.getElementById("back");
	
	// pause the speaking
	pauseSpeakItems();

	if(window.widget) widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if(window.widget) setTimeout('widget.performTransition();', 0);
	
	// if there are no bookmarks, refresh preferences pane
	if(isNull(feeds) || feeds.length<1) refreshPreferences(true);
	// initially, there is no need to refresh items
	needsRefresh=false;
}

// Flip to front
function hideBack(){
	var front=document.getElementById("front");
	var back=document.getElementById("back");
	
	if(window.widget) widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";
	
	if(window.widget) setTimeout('widget.performTransition();', 0);
	document.getElementById('fliprollie').style.display = 'none';
	document.getElementById('refreshrollie').style.display = 'none';
	
	// if bookmarks changed, refresh
	if(needsRefresh) waitAndRefresh(0);
}

// Display the info and refresh button
var flipShown = false;
var animation = {duration:0, starttime:0, to:0.8, now:0.0, from:0.0, firstElement:null, timer:null};
function mouseMove (event){
	// show flip button
	if (!flipShown){
		if (animation.timer != null){
			clearInterval (animation.timer);
			animation.timer  = null;
		}
                
		var starttime = (new Date).getTime() - 13;
                
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.secondElement = document.getElementById ('refreshButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.8;
		animate();
		flipShown = true;
	}
}

function mouseExit (event){
	// hide flip button
	if (flipShown){
		// fade in the info button
		if (animation.timer != null){
			clearInterval (animation.timer);
			animation.timer  = null;
		}
                
		var starttime = (new Date).getTime() - 13;
                
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.secondElement = document.getElementById ('refreshButton');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate(){
	var T;
	var ease;
	var time = (new Date).getTime();
                   
	T = limit_3(time-animation.starttime, 0, animation.duration);
        
	if (T >= animation.duration){
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
        
	animation.firstElement.style.opacity = animation.now;
	animation.secondElement.style.opacity = animation.now;
}

function limit_3 (a, b, c){
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease){
	return from + (to - from) * ease;
}

function enterFlip(event){
	document.getElementById('fliprollie').style.display = 'block';
}
function exitFlip(event){
	document.getElementById('fliprollie').style.display = 'none';
}

function enterRefresh(event){
	document.getElementById('refreshrollie').style.display = 'block';
}
function exitRefresh(event){
	document.getElementById('refreshrollie').style.display = 'none';
}

function enterRefreshBookmarks(event){
	document.getElementById('refreshbookmarksrollie').style.display = 'block';
}
function exitRefreshBookmarks(event){
	document.getElementById('refreshbookmarksrollie').style.display = 'none';
}



// ----------------------------
// JavaScript basic functions
// ----------------------------

function isArray(a) {
    return isObject(a) && a.constructor == Array;
}

function isBoolean(a) {
    return typeof a == 'boolean';
}

function isEmpty(o) {
    var i, v;
    if (isObject(o)) {
        for (i in o) {
            v = o[i];
            if (isUndefined(v) && isFunction(v)) {
                return false;
            }
        }
    }
    return true;
}

function isFunction(a) {
    return typeof a == 'function';
}

function isNull(a) {
    if ((typeof a == 'object' && !a) || typeof a == 'undefined')
	    return true;
	else return false;
}

function isNumber(a) {
    return typeof a == 'number' && isFinite(a);
}

function isObject(a) {
    return (a && typeof a == 'object') || isFunction(a);
}

function isString(a) {
    return typeof a == 'string';
}

function isUndefined(a) {
    return typeof a == 'undefined';
} 